package meta.system.bop;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Augmentation of {@link meta.system.bop.BOPArrayPersistable}.
 */
public aspect BOPCollectionPersistableAugment{
	
	/**
	 * Variable to hold the Unique identifier of the entity that contains a collection with this instance in.
	 */
	public Object BOPCollectionPersistable.strParentID = null;
	
	public boolean BOPCollectionPersistable.IDModified = false;
	public boolean BOPCollectionPersistable.FieldNameModified = false;
	
	/**
	 * Allows the use of implementing class's in multiple other classes (as long as they use different field names of course ;) ).
	 */
	//TODO this should be changed to the class/type of the containing class.
	public String BOPCollectionPersistable.strClassName = null;
	
	
	pointcut modifiedBeingCleared(BOPCollectionPersistable entity) : call(public void BOPPersistable+.clearModified()) &&
	target(BOPCollectionPersistable+) && target(entity);
	
	before(BOPCollectionPersistable entity) : modifiedBeingCleared(entity){
		entity.IDModified = false;
	}
	
	/**
	 * Joins on the execution of the setFromResultSet method when called on BOPArrayPersistable+.
	 */
//	pointcut setFromResultSet(BOPCollectionPersistable entity, ResultSet resSet) : execution(public void BOPCollectionPersistable+.setFromResultSet(ResultSet)) &&
	//														this(entity) && args(resSet);
	
	/**
	 * Executes before the implementors variable sets, ensures the ParentID is extracted.
	 */
	/*before(BOPCollectionPersistable entity, ResultSet resSet) throws SQLException : setFromResultSet(entity, resSet){
		entity.strClassName = resSet.getString("strClassName");
		try{
			((BOPCollectionPersistable)entity).setParentID(resSet.getInt("strParentID"));
		}catch(SQLException e){
			//is it  astring instead?
			((BOPCollectionPersistable)entity).setParentID(resSet.getString("strParentID"));
		}
	}*/
	
	/**
	 * Get ID of the entiy that owns the collection this instance is part of.
	 * @return The ID of the parent.
	 */
	public Object BOPCollectionPersistable.getParentID() {
		return strParentID;
	}

	/**
	 * Sets the ID of the entity that owns the collection this instance is a part of. 
	 * @param intParentID The ID of the owning entity.
	 */
	public void BOPCollectionPersistable.setParentID(Object strParentID) {
		this.strParentID = strParentID;
		IDModified = true;
	}
	
	public void BOPCollectionPersistable.setClassName(String fName){
		this.strClassName = fName;
		FieldNameModified = true;
	}
	
	public String BOPCollectionPersistable.getClassName(){
		return this.strClassName;
	}
}
