package meta.system.bop;

import java.sql.ResultSet;
import java.sql.SQLException;


/**
 * Augementation of {@link meta.system.bop.BOPHostSpecificEntity}.
 */
public aspect BOPHostSpecificEntityAugment {
	/**
	 * The name of box the rest of the data is relavent to.
	 */
	public String BOPHostSpecificEntity.strHost = null;
	
	public boolean BOPHostSpecificEntity.hostModified = false;
	
	
	pointcut modifiedBeingCleared(BOPHostSpecificEntity entity) : call(public void BOPPersistable+.clearModified()) &&
	target(BOPHostSpecificEntity) && target(entity);
	
	before(BOPHostSpecificEntity entity) : modifiedBeingCleared(entity){
		entity.hostModified = false;
	}
	
	
	/**
	 * Joins on the execution of the setFromResultSet method.
	 */
	pointcut setFromResultSet(BOPHostSpecificEntity entity, ResultSet resSet) : call(public void BOPPersistable+.setFromResultSet(ResultSet)) &&
	target(entity) && target(BOPHostSpecificEntity+) && args(resSet) && !withincode(public void BOPPersistable+.setFromResultSet(ResultSet));
	
	/**
	 * Executes before the implementor sets its variables, ensures the unique identifier for the instance is extracted.
	 */
	before(BOPHostSpecificEntity entity, ResultSet resSet) throws SQLException : setFromResultSet(entity, resSet){
		entity.strHost = resSet.getString("strHost");		
	}
	
	/*
	pointcut setHost (BOPHostSpecificEntity entity) : set(* BOPHostSpecificEntity.strHost) && this(entity);
	
	before(BOPHostSpecificEntity entity) : setHost(entity){		
		AjType type = AjTypeSystem.getAjType(entity.getClass());
		try {
			Field strHostField = AjType.getDeclaredITDField("strHost", type);
			
			if(!entity.modified.contains(strHostField)){
				entity.modified.add(strHostField);
			}
		} catch (NoSuchFieldException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}*/
	
	
	/**
	 * Gets the value of {@link #strHost}, if its null then calls "System.getenv("HOSTNAME")" and sets it.
	 * @return The name of the box this instance is relavent to.
	 */
	public String BOPHostSpecificEntity.getHost(){
		/*Seemed like a good idea, but because of how i ended up implementing the addition of thses fields to
		 * the coreSql method, it would make it impossible to retireve any details for other boxes, which is a likely senario.
		if(strHost == null){
			this.strHost = System.getenv("HOSTNAME");
		}*/
		return this.strHost;
	}
	
	/**
	 * Sets the name of the host. Useful for when retrieving from the database.
	 * @param host The name of the box this instance is relavent to.
	 */
	public void BOPHostSpecificEntity.setHost(String host){
		strHost = host;
		hostModified = true;
	}
}
