package meta.system.bop;


/**
 * Base Interface for persistence layer, see {@link meta.system.bop.BOPPersistableAugment}. T should be implemented
 * to the object type of the primary key you want to use.
 * @author tom
 */
public interface BOPPersistable {
		
	/**
	 * Accessor to the flag defined in the Augment for defining weather the entity needs inserting or is an update. If
	 * true then the entity should be inserted as a new record, if false then an update is required. 
	 * @return
	 */
	public boolean isOriginal();
	
	public void setOriginal(boolean boo);
}
