package meta.system.monitors;

/**
 * Adds ChangedMonitor logic to implementors.
 * @author tom * 
 */
public interface ChangeMonitor extends Monitor<ChangeMonitorInterest> {
	
	/**
	 * Implementors should test their resource for any modification. 
	 * @return Should be true if the resource has change din any way.
	 * @throws Exception if thrown monitor will assume the resource has been changed.
	 */
	public boolean resourceChanged() throws Exception;
}
