package meta.system.monitors;

import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * 
 */
public aspect ChangedMonitorAugment extends MonitorAugment<ChangeMonitorInterest>{

	public void ChangeMonitor.addInterested(ChangeMonitorInterest inter){
		this.interested.add(inter);
	}
	public void ChangeMonitor.removeInterested(ChangeMonitorInterest inter){
		this.interested.remove(inter);
	}
	
	public void ChangeMonitor.run(){
		Thread.currentThread().setName(this.getClass().getName());
		
		boolean change = true;
		try{
			change = this.resourceChanged();
		}catch(Exception e){
			StringWriter stackTrace = new StringWriter();
			e.printStackTrace(new PrintWriter(stackTrace));			
			log.fatal(e+" occured when checking for resource change. Assuming it has. Trace - "+stackTrace);
		}
		
		if(change){
			log.debug("Resource has changed");
			//alert all interested partys
			for(ChangeMonitorInterest chaney : this.interested){
				try {
					chaney.resourceModified(this);
				} catch (Exception e) {
					StringWriter stackTrace = new StringWriter();
					e.printStackTrace(new PrintWriter(stackTrace));	
					log.warn(e+" occured when informing a "+chaney.getClass().getName()+" of a change. Trace - "+stackTrace);
				}
			}
		}

		//log.debug("Updating run at for "+this.getClass().getName());
		this.lastRun = System.currentTimeMillis();
		
		this.pool.execute(this);
	}
}
