package meta.system.monitors;

import org.apache.log4j.*;
import java.util.LinkedList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.Delayed;

/**
 * Provides base monitor logic.
 */
public abstract aspect MonitorAugment<M extends MonitorInterest> {
	
	ExecutorService Monitor.pool = null;

	public static Logger log = Logger.getLogger("meta.utils.monitors.Monitor");	

	LinkedList<M> Monitor.interested = new LinkedList<M>();
	
	public long Monitor.lastRun = System.currentTimeMillis();
	
	public long Monitor.delayTime = 1000;
	
	public void Monitor.startMonitoring(){
		this.pool.execute(this);
	}

	public ExecutorService Monitor.getPool() {
		return this.pool;
	}

	public void Monitor.setPool(ExecutorService pool) {
		this.pool = pool;
	}
	
	public long Monitor.getDelay(TimeUnit unit){
		return (this.lastRun + this.delayTime)-System.currentTimeMillis();
	}
	
	public int Monitor.compareTo(Delayed delly){
		long thisDelly = this.getDelay(TimeUnit.MILLISECONDS);
		long thatDelly = delly.getDelay(TimeUnit.MILLISECONDS);
		
		if(thisDelly == thatDelly)return 0;
		if(thisDelly > thatDelly)return 1;
		return -1;
	}
		
	/*
	//point cut on exstentions runs to update the run var
	pointcut beenRun(Monitor mona) : execution(public void Monitor+.run()) && this(mona);
	
	before(Monitor mona) : beenRun(mona){
		log.debug("Updating run at for "+mona.getClass().getName());
		mona.lastRun = System.currentTimeMillis();
	}
	*/
}
