package meta.system.monitors;

/**
 * Adds UpDown monitoring logic to implementors. Implementors need only implement the resourceAvailible method returning the
 * state of affairs and the augment will do the rest.
 * @author tom
 */
public interface UpDownMonitor extends Monitor<UpDownMonitorInterest>{

	/**
	 * Implementors should test their resource.
	 * @return true if resource is availible false otherwise.
	 * @throws Exception If any exception is thrown false will be assumed.
	 */
	public boolean resourceAvailible() throws Exception;
	
}
