package meta.system.objectpools;


import org.apache.commons.pool.impl.GenericObjectPool;
import meta.system.registry.Registable;
import org.apache.log4j.Logger;

/**
 * Adds behaviour to return a Cached object to its pool after its been deregistered from the cache.
 */
public aspect CachedAnPooledAugment {

	static final Logger log = Logger.getLogger("Augment");
	
	/*
	 * IDT's
	 */	
	public GenericObjectPool CachedAnPooled.pool = null;
	
	public void CachedAnPooled.setPool(GenericObjectPool pool){
		this.pool = pool;
	}
	
	
	/*
	 * PointCuts
	 */	
	pointcut deregister(CachedAnPooled entity) : execution(public void Registable+.deregistered( .. )) && this(entity);
	
	after(CachedAnPooled entity) : deregister(entity){
		if(entity.pool != null){
			try{
				log.debug("Returning "+entity.getName()+" to its pool");
				entity.pool.returnObject(entity);
			}catch(Exception e){
				throw new RuntimeException(e);
			}
			return;
		}
		log.fatal(entity.getName()+"'s pool has not been set, this causes a problem when trying to return it to it!");
	}
	
}
