package meta.system.xml;

/**
 * Implementors should provide methods so that an instance can be converted into XML and then back again. The two methods
 * must complement each other such that the result of a create should being past to a set result in an indentical instance in
 * term of contents of course.
 * without loss of any useful information.
 * @author tom
 *
 */
public interface XMLRepresentable {
	
	/**
	 * Implementation should create a String contianing XML that contains all the useful information of the particular
	 * instance. 
	 * @return
	 */
	public String createXMLRep();
	
	/**
	 * Implementations should create instance values matching those in the past XML.
	 * @param xml
	 */
	public void setFromXML(String xml);
}
