package meta.web;

import javax.servlet.http.HttpServletRequest;
import meta.exceptions.ServletException;
import meta.system.objectpools.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;


/**
 * Augmentation for ServletServiceMethods interface.
 */
public aspect ServletServiceMethodsAugment {
	
	/**
	 * Checks that the request is XML if so creates a String to represent it, if not throws a ServletException
	 */
	public String meta.web.ServletServiceMethods.createXMLStringFromRequest(HttpServletRequest httpRequest) throws ServletException{
		if(httpRequest.getContentType().equalsIgnoreCase("text/xml")){
			StringBuilder reqBuild = GetInstance.stringBuilder();
			BufferedReader reader = null;
			try{
				String tempo = "";
				reader = httpRequest.getReader();
				while((tempo = reader.readLine()) != null){
					reqBuild.append(tempo);
				}
				return reqBuild.toString();
			}catch(IOException e){
				StringWriter stackTrace = new StringWriter();
				e.printStackTrace(new PrintWriter(stackTrace));
				throw new ServletException(e+" occured when trying to read in the request. Trace - "+stackTrace);
			}finally{				
				GetInstance.stringBuilderReturn(reqBuild);
				try{
					if(reader != null)reader.close();
				}catch(IOException e){
					throw new ServletException("Occured when trying to close the BufferReader i was using to pull the request.", e);
				}
			}
		}
		
		throw new ServletException("Requests content-type is not \"text/xml\", only requests mark as such are excepted, so "+httpRequest.getContentType()+" is'nt.");
		
	}
	
}
